/*   DUMP a file in Hex and ASCII    */

#include "simpletools.h"                      // Include simpletools

int DO = 22, CLK = 23, DI = 24, CS = 25;      // SD card pins on Propeller activity board

FILE* sourceFp;                               //the file pointer
int c;                                        //character straight from file
int counter = -1;                             //counts characters from the file beginning with zero
int offset;                                   //counts character on each line
char filename[20];                            //user specfied file name 

int main(void)                                // main function
{  
  sd_mount(DO, CLK, DI, CS);                  // Mount SD card
  putStr("Specify File Name:   ");            //request file name   
  getStr(filename, 20);
  
  sourceFp = fopen(filename, "r");          // open file for reading
  if (sourceFp == NULL) {
    putStr("Could not open file\n");
    return -1;                              //error exit
  }    
  
  while ((c = fgetc(sourceFp)) != EOF){    //get one character, test for end of file
    if ((++counter % 16) == 0){            //16 characters per line of display
      putChar(NL);
      putHexLen(counter,5);                //character count in hex
      putStr("  ");
    }                                      //end of if counter
    
    offset = counter % 16;                 //characters on this line      
    putChar(CRSRX);                        //line up for hex
    putChar((offset*3) + 8);
    putHexLen(c, 2);                       //show hex
    putChar(CRSRX);                        //line up for ASCII
    putChar((offset*2) + 64);    
    if ((c > 0x1F) && (c < 0x80)) {        //see if printable ASCII  
      putChar(c);                          //print it
    }
    else {
      putChar('.');                        //otherwise a marker
    }            
    pause(100);                            //dont overrun IDE buffer       
   }    //end of while       
          
  fclose(sourceFp);
  putStr("\n Program complete\n");
  return 0;                               //all's well, etc.                                      
}   //end of main

